routes/web.php
<?php

use App\Http\Controllers\NoticiaController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [NoticiaController::class,'index'])->name('home');
Route::resource('noticias', NoticiaController::class)->parameters(['noticias' => 'noticia'])->names('noticias');

app/Models/Noticia.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Noticia extends Model
{
    use HasFactory;
    use SoftDeletes;
    
    //protected $guarded = ['titulo'];// los que no se pueden guardar
    protected $fillable = ['titulo', 'slug', 'contenido', 'tipo'];
    protected $guarded = [];
    // muestra url amigables
    public function getRouteKeyName()
    {
        return 'slug';
    }
}

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/NoticiaController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\StoreNoticia;
use App\Http\Requests\UpdateNoticia;
use App\Models\Noticia;
use Illuminate\Http\Request;
use Illuminate\Support\Str;

class NoticiaController extends Controller
{
    // papgina principañ
    public function index() {
        #$noticias = Noticia::all();
        $noticias = Noticia::orderBy('id','desc')->paginate(6);
        return view('noticias.index',compact('noticias'));
    }

    // llamando del formulario de creacion
    public function create() {
        return view('noticias.create');
        //return "Create";
    }

    // generar la lógica de guardadp
    //public function store(Request $request) {
    public function store(StoreNoticia $request) {
        
        if (!$request['tipo']){
            $request['tipo'] = 'Nacional';
        }
        $noticia_new  = new Noticia($request->all());
        $noticia_new['slug'] = Str::slug($noticia_new['titulo'],'-');
        $noticia_new->save();
        return redirect()->route('noticias.index');
    }

    // genera la logica del mostrado de un componente en específico
    public function show(Noticia $noticia){
        return view('noticias.show',compact('noticia'));
    }

    // edición de componentes, retorna el form de la edición
    public function edit($id) {
        $noticia = Noticia::find($id);
        return view('noticias.edit',compact('noticia'));
    }

    // actualización de un registro
    public function update(Noticia $noticia, UpdateNoticia $request) {
        if (!$request['tipo']){
            $request['tipo'] = 'Nacional';
        }
        $noticia->contenido = $request->contenido;
        $noticia->tipo =  $request->tipo;
        $noticia->save();
        return redirect()->route('noticias.show',$noticia);
        
    }

    // destrución del registro
    public function destroy(Noticia $noticia) {
        $noticia->delete();
        return redirect()->route('noticias.index');
    }
}

resources/views/layouts/base.blade.php
<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    
    <title> @yield('tittle') </title>
    <!--fav icon-->
    <!--estilos-->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-eOJMYsd53ii+scO/bJGFsiCZc+5NDVN2yr8+0RDqr0Ql0h+rP48ckxlpbzKgwra6" crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta3/dist/js/bootstrap.bundle.min.js" integrity="sha384-JEW9xMcG8R+pH31jmWH6WWP0WintQrMb4s7ZOdauHnUtxwoG2vI5DkLtS3qm9Ekf" crossorigin="anonymous"></script>
    
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" integrity="sha512-iBBXm8fW90+nuLcSKlbmrPcLa0OT92xO1BIsZ+ywDWZCvqsWgccV3gFoRBv0z+8dLJgyAHIhR35VZc2oM/gI1w==" crossorigin="anonymous" />

</head>
    <body>
        <!--header-->
        @include('layouts.partials.header')
        <main class="container">
            

            @yield('content')

            <!--footer-->
            
            <!--script-->
            <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta3/dist/js/bootstrap.bundle.min.js" integrity="sha384-JEW9xMcG8R+pH31jmWH6WWP0WintQrMb4s7ZOdauHnUtxwoG2vI5DkLtS3qm9Ekf" crossorigin="anonymous"></script>
        </main>
        
    </body>
</html>

resources/views/layouts/partials/header.blade.php
<nav class="navbar navbar-expand-lg navbar-light bg-light">
    <div class="container-fluid">
        <a class="navbar-brand" href="{{route('noticias.index')}}">Periodico Web</a>
        <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent"
            aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarSupportedContent">
            <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                <li class="nav-item">
                    <a class="nav-link active" aria-current="page" href=" {{ route('noticias.index')}} ">Inicio</a>
                </li>
            </ul>
            <form class="d-flex" action="" method="POST">
                <input class="form-control me-2" type="search" placeholder="Busqueda" aria-label="Search">
                <button class="btn btn-outline-success" type="submit">Filtrar</button>
            </form>
        </div>
    </div>
</nav>

resources/views/noticias/create.blade.php
@extends('layouts/base')

@section('tittle', 'Crear Noticias ')

@section('content')
    <h2>Crear Noticia</h2>
    <br>
    <form action=" {{route("noticias.store")}} " method="POST">
        @csrf

        <div class="mb-3">
            <label for="titulo-form" class="form-label">Titulo</label>
            <input type="text" class="form-control" name="titulo" placeholder="Titulo de la noticia"
                value="{{ old('titulo') }}">
            @error('titulo')
                <small class="text-danger">* {{ $message }}</small>
            @enderror
        </div>

        <div class="mb-3">
            <label for="content-form" class="form-label">Contenido</label>
            <textarea class="form-control" name="contenido" cols="40" rows="10">{{ old('contenido') }}</textarea>
            @error('contenido')
                <small class="text-danger">* {{ $message }}</small>
            @enderror
        </div>

        <div class="mb-3">
            <label class="form-label">Tipo de noticia</label>
            <div class="form-check">
                <input class="form-check-input" type="checkbox" name="tipo" Value="Internacional" id="check-internacional" {{old('tipo')? 'checked':''}}>
                <label class="form-check-label" for="check-internacional">Internacional</label>
            </div>
            <div class="form-text">Por defecto, la noticia sera de tipo nacional, selecione Internacional para cambiar el tipo</div>
        
        </div>  
        <button type="submit" class="btn btn-primary">Crear noticia</button>
    </form>

@endsection

resources/views/noticias/edit.blade.php
@extends('layouts/base')

@section('tittle', 'Crear Noticias ')

@section('content')
    <h3>Edición de Noticia</h2>
    
    <br>
    <form action=" {{route("noticias.update",$noticia)}} " method="POST">
        @csrf
        @method('put')

        <label for="titulo-form" class="form-label">Titulo</label>
        <h1>{{ $noticia->titulo }}</h1>
        

        <div class="mb-3">
            <label for="content-form" class="form-label">Contenido</label>
            <textarea class="form-control" name="contenido" cols="40" rows="10">{{ old('contenido',$noticia->contenido) }}</textarea>
            @error('contenido')
                <small class="text-danger">* {{ $message }}</small>
            @enderror
        </div>

        <div class="mb-3">
            <label class="form-label">Tipo de noticia</label>
            <label for="">{{old('tipo')}}</label>
            <div class="form-check">    
                <input class="form-check-input" type="checkbox" name="tipo" Value="Internacional" id="check-internacional" {{old('tipo',$noticia->tipo) == 'Internacional' ? 'checked':''}}>
                <label class="form-check-label" for="check-internacional">Internacional</label>
            </div>
            <div class="form-text">Por defecto, la noticia sera de tipo nacional, selecione Internacional para cambiar el tipo</div>

        </div>  
        <button type="submit" class="btn btn-primary">Actualizar noticia</button>
    </form>

@endsection

resources/views/noticias/index.blade.php
@extends('layouts/base')

@section('tittle', 'Noticias')

@section('content')
    <h2 >Noticias Principales</h2>
    <a class="btn btn-primary" href=" {{route('noticias.create')}} ">Crear noticia</a>
  
    <div class="row row-cols-2 row-cols-md-4 g-4 mt-2">
        @foreach ($noticias as $noticia)
            
            <div class="card m-3 p-1" >
                <div class="card-body">
                    <h4 class="card-title">{{$noticia->titulo}}</h4>
                    <p class="card-text"><small class="text-muted">{{$noticia->tipo}}</small></p>
                </div>
                <div class="card-footer">
                    <a class="btn btn-info" href="{{route('noticias.show',$noticia)}}" class="card-link">Ver noticia</a>
                </div>
                
            </div>
            
        @endforeach
    </div>
    <div class="row">
        {!! $noticias->links("pagination::bootstrap-4") !!}
    </div>
    
@endsection

resources/views/noticias/show.blade.php
@extends('layouts/base')

@section('tittle', 'Noticia')

@section('content')

    <div class="container">
        <div class="row">
            <div class="col-md-10">
                <article class="">
                    
                    <h2 class="">{{ $noticia->titulo }}</h2>
                    
                    <figure class="row mt-3 text-muted   ">
                        <p class="col"> {{ $noticia->created_at }} </p>
                        <figcaption class="col blockquote-footer text-end">
                            <cite >{{ $noticia->tipo}} </cite>
                        </figcaption>
                        <hr>
                    </figure>
                    <div class="flex">
                        <p class="text-justify" style="text-justify: inter-word; text-align: justify; ">
                            {{ $noticia->contenido }}
                        </p>
                    </div>
                </article>
            </div>
            <div class="col-md-2">
                <div class="p-4 align-right">
                    <p class="col">
                        <a class="btn btn-primary" href=" {{route("noticias.edit", $noticia->id)}} ">Editar</a>
                    </p>
                    <form  class="col" action="" method="POST">
                        @csrf
                        @method('delete')
                        <button type="submit" class="btn btn-danger">eliminar</button>
                    </form>
                </div>
            </div>
        </div>
        
    </div>

@endsection